/* -*- buffer-read-only: t -*- vi: set ro: */
/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (http://www.swig.org).
 * Version 1.3.21
 * 
 * This file is not intended to be easily readable and contains a number of 
 * coding conventions designed to improve portability and efficiency. Do not make
 * changes to this file unless you know what you are doing--modify the SWIG 
 * interface file instead. 
 * ----------------------------------------------------------------------------- */

/* Implementation : GUILE */

extern "C" {

extern void
SWIG_init (void)
;

}

#ifdef __cplusplus
template<class T> class SwigValueWrapper {
    T *tt;
public:
    SwigValueWrapper() : tt(0) { }
    SwigValueWrapper(const SwigValueWrapper<T>& rhs) : tt(new T(*rhs.tt)) { }
    SwigValueWrapper(const T& t) : tt(new T(t)) { }
    ~SwigValueWrapper() { delete tt; } 
    SwigValueWrapper& operator=(const T& t) { delete tt; tt = new T(t); return *this; }
    operator T&() const { return *tt; }
    T *operator&() { return tt; }
private:
    SwigValueWrapper& operator=(const SwigValueWrapper<T>& rhs);
};                                                    
#endif

/* -*- c -*-
 * -----------------------------------------------------------------------
 * Lib/guile/guile_gh_run.swg
 *
 * Guile GH runtime file
 * Copyright (C) 2000 Matthias Koeppe
 * ----------------------------------------------------------------------- */

#include "guile/gh.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#ifdef __cplusplus
extern "C" {
#endif

#define SWIG_malloc(size) \
  SCM_MUST_MALLOC(size)
#define SWIG_free(mem) \
  scm_must_free(mem)
#define SWIG_ConvertPtr(s, result, type, flags) \
  SWIG_Guile_GetPtr(s, result, type)
#define SWIG_MustGetPtr(s, type, argnum, flags) \
  SWIG_Guile_MustGetPtr(s, type, argnum, FUNC_NAME)
#define SWIG_NewPointerObj(ptr, type, owner) \
  SWIG_Guile_MakePtr((void*)ptr, type)

/* Ignore object-ownership changes in gh mode */
#define SWIG_Guile_MarkPointerNoncollectable(s) (s)
#define SWIG_Guile_MarkPointerDestroyed(s) (s)
  
#define SWIG_contract_assert(expr, msg)				\
  if (!(expr))							\
    scm_error(gh_symbol2scm("swig-contract-assertion-failed"),	\
	      (char *) FUNC_NAME, (char *) msg,			\
	      SCM_EOL, SCM_BOOL_F); else

#if defined(SWIG_NOINCLUDE)
#	define SWIGSTATIC
#elif defined(SWIG_GLOBAL)
#	define SWIGSTATIC
#else
#	define SWIGSTATIC static
#endif

#define GH_NOT_PASSED    SCM_UNDEFINED
#define GH_UNSPECIFIED   SCM_UNSPECIFIED

#define SWIG_APPEND_VALUE(object)						\
    if (gswig_result == GH_UNSPECIFIED)						\
        gswig_result = object;							\
    else {									\
        if (!gswig_list_p) {							\
	    gswig_list_p = 1;							\
	    gswig_result = gh_list(gswig_result, object, GH_NOT_PASSED);	\
        }									\
        else									\
            gswig_result = gh_append2(gswig_result,				\
                                      gh_list(object, GH_NOT_PASSED));		\
    }

#define GUILE_APPEND_RESULT SWIG_APPEND_VALUE
  
/* scm_values was implemented on C level in 1.4.1, and the prototype
   is not included in libguile.h, so play safe and lookup `values'... */
#define GUILE_MAYBE_VALUES						\
    if (gswig_list_p)							\
        gswig_result = gh_apply(gh_lookup("values"), gswig_result);
    
#define GUILE_MAYBE_VECTOR				\
    if (gswig_list_p)					\
        gswig_result = gh_list_to_vector(gswig_result);

static char *
SWIG_scm2str (SCM s)
{
  return gh_scm2newstr (s, NULL);
}

#define GSWIG_scm2str SWIG_scm2str

/* SCM_CHAR and SCM_CHARP were introduced in Guile 1.4; the following is for
   1.3.4 compatibility. */
#ifndef SCM_CHAR
#  define SCM_CHAR SCM_ICHR
#endif
#ifndef SCM_CHARP
#  define SCM_CHARP SCM_ICHRP
#endif

/* This function replaces gh_scm2char, which is broken in Guile 1.4 */
static char
GSWIG_scm2char (SCM s)
{
  if (SCM_CHARP(s)) return SCM_CHAR(s);
  scm_wrong_type_arg(NULL, 0, s);
}
#define gh_scm2char GSWIG_scm2char

/* More 1.3.4 compatibility */
#ifndef SCM_INPUT_PORT_P
#  define SCM_INPUT_PORT_P SCM_INPORTP
#  define SCM_OUTPUT_PORT_P SCM_OUTPORTP
#endif

/* Type system */

typedef void *(*swig_converter_func)(void *);
typedef struct swig_type_info *(*swig_dycast_func)(void **);

typedef struct SwigPtrType SwigPtrType;

typedef struct swig_type_info {
  const char  *name;
  swig_converter_func converter;
  const char  *str;
  void        *clientdata;
  size_t tag;
  swig_dycast_func        dcast;
} swig_type_info;

SWIGSTATIC void
SWIG_Guile_RegisterTypes (swig_type_info **table,
			  swig_type_info **init);

/* Register a new type-mapping with the type-checker.  origtype is the
   original datatype and newtype is an equivalent type.  cast is optional
   pointer to a function to cast pointer values between types (this is
   typically used to cast pointers from derived classes to base classes in
   C++).  */

SWIGSTATIC void
SWIG_RegisterMapping (const char *origtype, const char *newtype,
                      swig_converter_func cast);


/* Dynamic pointer casting. Down an inheritance hierarchy */
SWIGSTATIC swig_type_info * 
SWIG_TypeDynamicCast(swig_type_info *ty, void **ptr);

/* Register SWIG smobs with Guile.  */
SWIGSTATIC void
SWIG_Guile_Init();

/* Initialization function for this SWIG module; actually renamed by a
   #define */
/* extern void SWIG_init(); */

/* Get a pointer value from a smob.  If there is a type-mismatch,
   return nonzero; on success, return 0.  */
SWIGSTATIC int
SWIG_Guile_GetPtr (SCM s, void **result, swig_type_info *type);

/* Get a pointer value from a smob.  If there is a type-mismatch,
   signal a wrong-type-arg error for the given argument number. */
SWIGSTATIC void *
SWIG_Guile_MustGetPtr (SCM s, swig_type_info *type,
		       int argnum, const char *func_name);

/* Make a smob from a pointer and typeinfo.  */
SWIGSTATIC SCM
SWIG_Guile_MakePtr (void *ptr, swig_type_info *type);

/* Get arguments from an argument list */
SWIGSTATIC int
SWIG_Guile_GetArgs (SCM *dest, SCM rest,
		    int reqargs, int optargs,
		    const char *procname);

typedef SCM (*swig_guile_proc)();

#ifdef __cplusplus
}
#endif

/* guiledec.swg ends here */

#ifndef SWIG_NOINCLUDE
/* SWIG pointer structure */

#ifdef __cplusplus
extern "C" {
#endif

struct SwigCast {
  unsigned short      type;		  /* Index into SwigPtrTbl          */
  void               *(*cast)(void *);    /* Pointer casting function       */
  struct SwigCast    *next;		  /* Linked list pointer            */
};

struct SwigPtrType {
  const char         *name;               /* Datatype name                  */
  const char	     *prettyname;         /* Pretty datatype name           */
  unsigned short      tag;		  /* Index in SwigPtrTable          */
  struct SwigCast    *cast;		  /* List of compatible types       */
};

/* Some variables  */

static int SwigPtrMax  = 64;            /* Max entries that can be held */
                                        /* (may be adjusted dynamically) */
static int SwigPtrN    = 0;             /* Current number of entries */
static int SwigPtrSort = 0;             /* Status flag indicating sort */

/* Pointer table */
static SwigPtrType *SwigPtrList = 0;    /* Table containing types and
					   equivalences; items will only
                                           be appended */
static size_t *SwigPtrTbl = 0;          /* Sorted indirect table; items will
					   be inserted */

/* Sort comparison function */
static int
swigsort (const void *data1, const void *data2)
{
  size_t index1 = * (size_t *) data1;
  size_t index2 = * (size_t *) data2;
  return strcmp(SwigPtrList[index1].name, SwigPtrList[index2].name);
}

/* Register a new datatype with the type-checker */
SWIGSTATIC size_t
SWIG_RegisterType (const char *type, const char *prettyname)
{
  int i;

  /* Allocate the pointer table if necessary */
  if (!SwigPtrList) {
    SwigPtrList = (SwigPtrType *) malloc(SwigPtrMax*sizeof(SwigPtrType));
    SwigPtrTbl = (size_t *) malloc(SwigPtrMax*sizeof(size_t));
    SwigPtrN = 0;
  }
  /* Grow the table if necessary */
  if (SwigPtrN >= SwigPtrMax) {
    SwigPtrMax = 2*SwigPtrMax;
    SwigPtrList = (SwigPtrType *) realloc((char *) SwigPtrList,
					  SwigPtrMax*sizeof(SwigPtrType));
    SwigPtrTbl = (size_t *) realloc((char *) SwigPtrTbl,
				    SwigPtrMax*sizeof(size_t));
  }
  /* Look up type */
  for (i = 0; i < SwigPtrN; i++)
    if (strcmp(SwigPtrList[i].name,type) == 0) {
      if (prettyname!=NULL)
	SwigPtrList[i].prettyname = prettyname;
      return i;
    }
  {
    struct SwigPtrType *t;
    size_t tag;
#if 0
    fprintf(stderr, "New type: %s\n", type);
#endif
    tag = SwigPtrTbl[SwigPtrN] = SwigPtrN;
    t = &SwigPtrList[tag];
    t->name = type;
    t->prettyname = prettyname;
    t->tag = SwigPtrN;
    t->cast = NULL;
    SwigPtrN++;
    SwigPtrSort = 0; 
    return tag;
  }
}

/* Register two data types and their mapping with the type checker. */
SWIGSTATIC void
SWIG_RegisterMapping (const char *origtype, const char *newtype,
		      swig_converter_func cast)
{
  size_t t = SWIG_RegisterType(origtype, NULL);

  if (newtype!=NULL) {
    size_t t1 = SWIG_RegisterType(newtype, NULL);
    struct SwigCast *c;
    /* Check for existing cast */
    for (c = SwigPtrList[t].cast; c && c->type!=t1; c=c->next) /* nothing */;
    if (c) {
      if (cast) c->cast = cast;
    }
    else {
      c = (struct SwigCast *) malloc(sizeof(struct SwigCast));
      c->type = t1;
      c->cast = cast;
      c->next = SwigPtrList[t].cast;
      SwigPtrList[t].cast = c;
    }
  }
}

/* Sort table */

static void
SWIG_SortTable (void)
{
  qsort ((void *) SwigPtrTbl, SwigPtrN, sizeof(size_t), swigsort);
  /* Indicate that everything is sorted */
  SwigPtrSort = 1;
}

/* Look up pointer-type entry in table */

static int
swigcmp (const void *key, const void *data)
{
  char *k = (char *) key;
  size_t index = *(size_t *)data;
  return strcmp(k, SwigPtrList[index].name);
}

static SwigPtrType *
SWIG_GetPtrType (const char *_t)
{
  size_t *result;
  if (!SwigPtrSort) SWIG_SortTable();
  result = (size_t *) bsearch(_t, SwigPtrTbl, SwigPtrN, sizeof(size_t), swigcmp);
  if (result!=NULL) return SwigPtrList+*result;
  else return NULL;
}

/* Cast a pointer if possible; returns 1 if successful */

static int
SWIG_Cast (void *source, size_t source_type,
	   void **ptr, size_t dest_type)
{
  if (dest_type != source_type) {
    /* We have a type mismatch.  Will have to look through our type
       mapping table to figure out whether or not we can accept this
       datatype.  */
    struct SwigCast *c;
    for (c = SwigPtrList[dest_type].cast;
	 c && c->type!=source_type; c = c->next) /* nothing */;
    if (c) {
      /* Get pointer value. */
      if (c->cast) *ptr = (*(c->cast))(source);
      else *ptr = source;
      return 1;
    }
    /* Didn't find any sort of match for this data.
       Get the pointer value and return false.  */
    *ptr = source;
    return 0;
  } else {
    /* Found a match on the first try.  Return pointer value.  */
    *ptr = source;
    return 1;
  }
}

/* Dynamic pointer casting. Down an inheritance hierarchy */
SWIGSTATIC swig_type_info * 
SWIG_TypeDynamicCast(swig_type_info *ty, void **ptr) 
{
  swig_type_info *lastty = ty;
  if (!ty || !ty->dcast) return ty;
  while (ty && (ty->dcast)) {
     ty = (*ty->dcast)(ptr);
     if (ty) lastty = ty;
  }
  return lastty;
}

/* Function for getting a pointer value */

static unsigned long swig_tag = 0;

SWIGSTATIC SCM
SWIG_Guile_MakePtr (void *ptr, swig_type_info *type)
{
  if (ptr==NULL) return SCM_EOL;
  SCM_RETURN_NEWSMOB((((unsigned long)type->tag << 16) | swig_tag),
		     ptr);
}

/* Return 0 if successful. */
SWIGSTATIC int
SWIG_Guile_GetPtr(SCM s, void **result, swig_type_info *type)
{
  if (SCM_NULLP(s)) {
    *result = NULL;
    return 0;
  }
  else if (SCM_NIMP(s)
	   && (unsigned long) SCM_TYP16(s) == swig_tag) {
    if (type) 
      return !SWIG_Cast((void *) SCM_CDR(s),
			(long) SCM_CAR(s) >> 16,
			result, type->tag);
    else {
      *result = (void *) SCM_CDR(s);
      return 0;
    }
  }
  return 1;
}

SWIGSTATIC void *
SWIG_Guile_MustGetPtr (SCM s, swig_type_info *type,
		       int argnum, const char *func_name)
{
  void *result;
  if (SWIG_Guile_GetPtr(s, &result, type)) {
    /* type mismatch */
    scm_wrong_type_arg((char *) func_name, argnum, s);
  }
  return result;
}

/* Init */

static int
print_swig (SCM swig_smob, SCM port, scm_print_state *pstate)
{
  scm_puts((char *) "#<swig ", port);
  if (SwigPtrList[(long) SCM_CAR(swig_smob) >> 16].prettyname != NULL)
    scm_puts((char*) SwigPtrList[(long) SCM_CAR(swig_smob) >> 16].prettyname, port);
  else scm_puts((char*) SwigPtrList[(long) SCM_CAR(swig_smob) >> 16].name, port);
  scm_puts((char *) " ", port);
  scm_intprint((long) SCM_CDR(swig_smob), 16, port);
  scm_puts((char *) ">", port);
  /* non-zero means success */
  return 1;
}

static SCM
equalp_swig (SCM A, SCM B)
{
  if (SCM_CAR(A) == SCM_CAR(B)
      && SCM_CDR(A) == SCM_CDR(B))
    return SCM_BOOL_T;
  else return SCM_BOOL_F;
}

SWIGSTATIC void
SWIG_Guile_Init (void)
{
  if (swig_tag == 0) {
    swig_tag = scm_make_smob_type_mfpe((char *) "swig", 0, NULL, NULL,
				       print_swig, equalp_swig);
  }
}

/* Convert datatype table */

SWIGSTATIC
void SWIG_Guile_RegisterTypes(swig_type_info **table,
			      swig_type_info **init)
{
  for (; *init; table++, init++) {
    swig_type_info *type = *table = *init;
    const char *origname = type->name;
    /* Register datatype itself and store pointer back */
    type->tag = SWIG_RegisterType(origname, type->str);
    /* Register compatible types */
    for (type++; type->name; type++)
      SWIG_RegisterMapping(origname, type->name, type->converter);
  }    
}

SWIGSTATIC int
SWIG_Guile_GetArgs (SCM *dest, SCM rest,
		    int reqargs, int optargs,
		    const char *procname)
{
  int i;
  int num_args_passed = 0;
  for (i = 0; i<reqargs; i++) {
    if (!SCM_CONSP(rest))
      scm_wrong_num_args(gh_str02scm((char *) procname));
    *dest++ = SCM_CAR(rest);
    rest = SCM_CDR(rest);
    num_args_passed++;
  }
  for (i = 0; i<optargs && SCM_CONSP(rest); i++) {
    *dest++ = SCM_CAR(rest);
    rest = SCM_CDR(rest);
    num_args_passed++;
  }
  for (; i<optargs; i++)
    *dest++ = GH_NOT_PASSED;
  if (!SCM_NULLP(rest))
    scm_wrong_num_args(gh_str02scm((char *) procname));
  return num_args_passed;
}

#ifdef __cplusplus
}
#endif

/* guile.swg ends here */

#endif


/* -------- TYPES TABLE (BEGIN) -------- */

#define  SWIGTYPE_p_FILE swig_types[0] 
#define  SWIGTYPE_p_Agedge_t swig_types[1] 
#define  SWIGTYPE_p_Agsym_t swig_types[2] 
#define  SWIGTYPE_p_Agraph_t swig_types[3] 
#define  SWIGTYPE_p_Agnode_t swig_types[4] 
#define  SWIGTYPE_p_p_void swig_types[5] 
static swig_type_info *swig_types[7];

/* -------- TYPES TABLE (END) -------- */



/* some language headers (e.g. php.h, ruby.h) leave these defined */
#undef PACKAGE_STRING
#undef PACKAGE_TARNAME
#undef PACKAGE_VERSION
#undef PACKAGE_NAME

#include "gvc.h"


/** New graphs */
/*** New empty graph */
extern Agraph_t *graph(char *name);
extern Agraph_t *digraph(char *name);
extern Agraph_t *strictgraph(char *name);
extern Agraph_t *strictdigraph(char *name);
/*** New graph from a dot-syntax string or file */
extern Agraph_t *readstring(char *string);
extern Agraph_t *read(char *filename);
extern Agraph_t *read(FILE *f);	
/*** Add new subgraph to existing graph */
extern Agraph_t *graph(Agraph_t *g, char *name);

/** New nodes */
/*** Add new node to existing graph */
extern Agnode_t *node(Agraph_t *g, char *name);

/** New edges */
/*** Add new edge between existing nodes */
extern Agedge_t *edge(Agnode_t *t, Agnode_t *h);
/*** Add a new edge between an existing tail node, and a named head node which will be induced in the graph if it doesn't already exist */
extern Agedge_t *edge(Agnode_t *t, char *hname);
/*** Add a new edge between an existing head node, and a named tail node which will be induced in the graph if it doesn't already exist */
extern Agedge_t *edge(char *tname, Agnode_t *h);
/*** Add a new edge between named tail  and head nodes which will be induced in the graph if they don't already exist */
extern Agedge_t *edge(Agraph_t *g, char *tname, char *hname);

/** Setting attribute values */
/*** Set value of named attribute of graph/node/edge - creating attribute if necessary */
extern char *setv(Agraph_t *g, char *attr, char *val);
extern char *setv(Agnode_t *n, char *attr, char *val);
extern char *setv(Agedge_t *e, char *attr, char *val);

/*** Set value of existing attribute of graph/node/edge (using attribute handle) */
extern char *setv(Agraph_t *g, Agsym_t *a, char *val);
extern char *setv(Agnode_t *n, Agsym_t *a, char *val);
extern char *setv(Agedge_t *e, Agsym_t *a, char *val);

/** Getting attribute values */
/*** Get value of named attribute of graph/node/edge */
extern char *getv(Agraph_t *g, char *attr);
extern char *getv(Agnode_t *n, char *attr);
extern char *getv(Agedge_t *e, char *attr);

/*** Get value of attribute of graph/node/edge (using attribute handle) */
extern char *getv(Agraph_t *g, Agsym_t *a);
extern char *getv(Agnode_t *n, Agsym_t *a);
extern char *getv(Agedge_t *e, Agsym_t *a);

/** Obtain names from handles */
extern char *nameof(Agraph_t *g);
extern char *nameof(Agnode_t *n);
//extern char *nameof(Agedge_t *e);
extern char *nameof(Agsym_t *a);

/** Find handles from names */
extern Agraph_t *findsubg(Agraph_t *g, char *name);
extern Agnode_t *findnode(Agraph_t *g, char *name);
extern Agedge_t *findedge(Agnode_t *t, Agnode_t *h);

/** */
extern Agsym_t *findattr(Agraph_t *g, char *name);
extern Agsym_t *findattr(Agnode_t *n, char *name);
extern Agsym_t *findattr(Agedge_t *e, char *name);

/** Misc graph navigators returning handles */
extern Agnode_t *headof(Agedge_t *e);
extern Agnode_t *tailof(Agedge_t *e);
extern Agraph_t *graphof(Agraph_t *g);
extern Agraph_t *graphof(Agedge_t *e);
extern Agraph_t *graphof(Agnode_t *n);
extern Agraph_t *rootof(Agraph_t *g);

/** Obtain handles of proto node/edge for setting default attribute values */
extern Agnode_t *protonode(Agraph_t *g);
extern Agedge_t *protoedge(Agraph_t *g);

/** Iterators */
/*** Iteration termination tests */
extern bool ok(Agraph_t *g);
extern bool ok(Agnode_t *n);
extern bool ok(Agedge_t *e);
extern bool ok(Agsym_t *a);

/*** Iterate over subgraphs of a graph */
extern Agraph_t *firstsubg(Agraph_t *g);
extern Agraph_t *nextsubg(Agraph_t *g, Agraph_t *sg);

/*** Iterate over supergraphs of a graph (obscure and rarely useful) */
extern Agraph_t *firstsupg(Agraph_t *g);
extern Agraph_t *nextsupg(Agraph_t *g, Agraph_t *sg);

/*** Iterate over edges of a graph */
extern Agedge_t *firstedge(Agraph_t *g);
extern Agedge_t *nextedge(Agraph_t *g, Agedge_t *e);

/*** Iterate over outedges of a graph */
extern Agedge_t *firstout(Agraph_t *g);
extern Agedge_t *nextout(Agraph_t *g, Agedge_t *e);

/*** Iterate over edges of a node */
extern Agedge_t *firstedge(Agnode_t *n);
extern Agedge_t *nextedge(Agnode_t *n, Agedge_t *e);

/*** Iterate over out-edges of a node */
extern Agedge_t *firstout(Agnode_t *n);
extern Agedge_t *nextout(Agnode_t *n, Agedge_t *e);

/*** Iterate over head nodes reachable from out-edges of a node */
extern Agnode_t *firsthead(Agnode_t *n);
extern Agnode_t *nexthead(Agnode_t *n, Agnode_t *h);

/*** Iterate over in-edges of a graph */
extern Agedge_t *firstin(Agraph_t *g);
extern Agedge_t *nextin(Agnode_t *n, Agedge_t *e);

/*** Iterate over in-edges of a node */
extern Agedge_t *firstin(Agnode_t *n);
extern Agedge_t *nextin(Agraph_t *g, Agedge_t *e);

/*** Iterate over tail nodes reachable from in-edges of a node */
extern Agnode_t *firsttail(Agnode_t *n);
extern Agnode_t *nexttail(Agnode_t *n, Agnode_t *t);

/*** Iterate over nodes of a graph */
extern Agnode_t *firstnode(Agraph_t *g);
extern Agnode_t *nextnode(Agraph_t *g, Agnode_t *n);

/*** Iterate over nodes of an edge */
extern Agnode_t *firstnode(Agedge_t *e);
extern Agnode_t *nextnode(Agedge_t *e, Agnode_t *n);

/*** Iterate over attributes of a graph */
extern Agsym_t *firstattr(Agraph_t *g);
extern Agsym_t *nextattr(Agraph_t *g, Agsym_t *a);

/*** Iterate over attributes of an edge */
extern Agsym_t *firstattr(Agedge_t *e);
extern Agsym_t *nextattr(Agedge_t *e, Agsym_t *a);

/*** Iterate over attributes of a node */
extern Agsym_t *firstattr(Agnode_t *n);
extern Agsym_t *nextattr(Agnode_t *n, Agsym_t *a);

/** Remove graph objects */
extern void rm(Agraph_t *g);
extern void rm(Agnode_t *n);
extern void rm(Agedge_t *e);

/** Layout */
/*** Annotate a graph with layout attributes and values using a specific layout engine */
extern void layout(Agraph_t *g, char *engine);

/** Render */
/*** Render a layout into attributes of the graph */
extern void render(Agraph_t *g); 

/*** Render a layout in a specific format */
extern void render(Agraph_t *g, char *format);
extern void render(Agraph_t *g, char *format, char *filename);
extern void render(Agraph_t *g, char *format, FILE *f);
extern void render(Agraph_t *g, char *format, void **data);

extern Agraph_t *graph(char *);
extern Agraph_t *digraph(char *);
extern Agraph_t *strictgraph(char *);
extern Agraph_t *strictdigraph(char *);
extern Agraph_t *readstring(char *);
extern Agraph_t *read(char *);
extern Agraph_t *read(FILE *);
extern Agraph_t *graph(Agraph_t *,char *);
extern Agnode_t *node(Agraph_t *,char *);
extern Agedge_t *edge(Agnode_t *,Agnode_t *);
extern Agedge_t *edge(Agnode_t *,char *);
extern Agedge_t *edge(char *,Agnode_t *);
extern Agedge_t *edge(Agraph_t *,char *,char *);
extern char *setv(Agraph_t *,char *,char *);
extern char *setv(Agnode_t *,char *,char *);
extern char *setv(Agedge_t *,char *,char *);
extern char *setv(Agraph_t *,Agsym_t *,char *);
extern char *setv(Agnode_t *,Agsym_t *,char *);
extern char *setv(Agedge_t *,Agsym_t *,char *);
extern char *getv(Agraph_t *,char *);
extern char *getv(Agnode_t *,char *);
extern char *getv(Agedge_t *,char *);
extern char *getv(Agraph_t *,Agsym_t *);
extern char *getv(Agnode_t *,Agsym_t *);
extern char *getv(Agedge_t *,Agsym_t *);
extern char *nameof(Agraph_t *);
extern char *nameof(Agnode_t *);
extern char *nameof(Agsym_t *);
extern Agraph_t *findsubg(Agraph_t *,char *);
extern Agnode_t *findnode(Agraph_t *,char *);
extern Agedge_t *findedge(Agnode_t *,Agnode_t *);
extern Agsym_t *findattr(Agraph_t *,char *);
extern Agsym_t *findattr(Agnode_t *,char *);
extern Agsym_t *findattr(Agedge_t *,char *);
extern Agnode_t *headof(Agedge_t *);
extern Agnode_t *tailof(Agedge_t *);
extern Agraph_t *graphof(Agraph_t *);
extern Agraph_t *graphof(Agedge_t *);
extern Agraph_t *graphof(Agnode_t *);
extern Agraph_t *rootof(Agraph_t *);
extern Agnode_t *protonode(Agraph_t *);
extern Agedge_t *protoedge(Agraph_t *);
extern bool ok(Agraph_t *);
extern bool ok(Agnode_t *);
extern bool ok(Agedge_t *);
extern bool ok(Agsym_t *);
extern Agraph_t *firstsubg(Agraph_t *);
extern Agraph_t *nextsubg(Agraph_t *,Agraph_t *);
extern Agraph_t *firstsupg(Agraph_t *);
extern Agraph_t *nextsupg(Agraph_t *,Agraph_t *);
extern Agedge_t *firstedge(Agraph_t *);
extern Agedge_t *nextedge(Agraph_t *,Agedge_t *);
extern Agedge_t *firstout(Agraph_t *);
extern Agedge_t *nextout(Agraph_t *,Agedge_t *);
extern Agedge_t *firstedge(Agnode_t *);
extern Agedge_t *nextedge(Agnode_t *,Agedge_t *);
extern Agedge_t *firstout(Agnode_t *);
extern Agedge_t *nextout(Agnode_t *,Agedge_t *);
extern Agnode_t *firsthead(Agnode_t *);
extern Agnode_t *nexthead(Agnode_t *,Agnode_t *);
extern Agedge_t *firstin(Agraph_t *);
extern Agedge_t *nextin(Agnode_t *,Agedge_t *);
extern Agedge_t *firstin(Agnode_t *);
extern Agedge_t *nextin(Agraph_t *,Agedge_t *);
extern Agnode_t *firsttail(Agnode_t *);
extern Agnode_t *nexttail(Agnode_t *,Agnode_t *);
extern Agnode_t *firstnode(Agraph_t *);
extern Agnode_t *nextnode(Agraph_t *,Agnode_t *);
extern Agnode_t *firstnode(Agedge_t *);
extern Agnode_t *nextnode(Agedge_t *,Agnode_t *);
extern Agsym_t *firstattr(Agraph_t *);
extern Agsym_t *nextattr(Agraph_t *,Agsym_t *);
extern Agsym_t *firstattr(Agedge_t *);
extern Agsym_t *nextattr(Agedge_t *,Agsym_t *);
extern Agsym_t *firstattr(Agnode_t *);
extern Agsym_t *nextattr(Agnode_t *,Agsym_t *);
extern void rm(Agraph_t *);
extern void rm(Agnode_t *);
extern void rm(Agedge_t *);
extern void layout(Agraph_t *,char *);
extern void render(Agraph_t *);
extern void render(Agraph_t *,char *);
extern void render(Agraph_t *,char *,char *);
extern void render(Agraph_t *,char *,FILE *);
extern void render(Agraph_t *,char *,void **);
static SCM
_wrap_graph__SWIG_0 (int argc, SCM *argv)
{
#define FUNC_NAME "graph"
    char *arg1 ;
    Agraph_t *result;
    int must_free1 = 0 ;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = SWIG_scm2str(argv[0]);
        must_free1 = 1;
    }
    gh_defer_ints();
    result = (Agraph_t *)graph(arg1);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agraph_t, 0);
    }
    if (must_free1 && arg1) SWIG_free(arg1);
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_digraph (SCM s_0)
{
#define FUNC_NAME "digraph"
    char *arg1 ;
    Agraph_t *result;
    int must_free1 = 0 ;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = SWIG_scm2str(s_0);
        must_free1 = 1;
    }
    gh_defer_ints();
    result = (Agraph_t *)digraph(arg1);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agraph_t, 0);
    }
    if (must_free1 && arg1) SWIG_free(arg1);
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_strictgraph (SCM s_0)
{
#define FUNC_NAME "strictgraph"
    char *arg1 ;
    Agraph_t *result;
    int must_free1 = 0 ;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = SWIG_scm2str(s_0);
        must_free1 = 1;
    }
    gh_defer_ints();
    result = (Agraph_t *)strictgraph(arg1);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agraph_t, 0);
    }
    if (must_free1 && arg1) SWIG_free(arg1);
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_strictdigraph (SCM s_0)
{
#define FUNC_NAME "strictdigraph"
    char *arg1 ;
    Agraph_t *result;
    int must_free1 = 0 ;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = SWIG_scm2str(s_0);
        must_free1 = 1;
    }
    gh_defer_ints();
    result = (Agraph_t *)strictdigraph(arg1);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agraph_t, 0);
    }
    if (must_free1 && arg1) SWIG_free(arg1);
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_readstring (SCM s_0)
{
#define FUNC_NAME "readstring"
    char *arg1 ;
    Agraph_t *result;
    int must_free1 = 0 ;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = SWIG_scm2str(s_0);
        must_free1 = 1;
    }
    gh_defer_ints();
    result = (Agraph_t *)readstring(arg1);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agraph_t, 0);
    }
    if (must_free1 && arg1) SWIG_free(arg1);
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_read__SWIG_0 (int argc, SCM *argv)
{
#define FUNC_NAME "read"
    char *arg1 ;
    Agraph_t *result;
    int must_free1 = 0 ;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = SWIG_scm2str(argv[0]);
        must_free1 = 1;
    }
    gh_defer_ints();
    result = (Agraph_t *)read(arg1);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agraph_t, 0);
    }
    if (must_free1 && arg1) SWIG_free(arg1);
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_read__SWIG_1 (int argc, SCM *argv)
{
#define FUNC_NAME "read"
    FILE *arg1 = (FILE *) 0 ;
    Agraph_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (FILE *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_FILE, 1, 0);
    }
    gh_defer_ints();
    result = (Agraph_t *)read(arg1);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agraph_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_read(SCM rest)
{
    SCM argv[1];
    int argc = SWIG_Guile_GetArgs (argv, rest, 0, 1, "read");
    if (argc == 1) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_FILE, 0);
        }
        if (_v) {
            return _wrap_read__SWIG_1(argc,argv);
        }
    }
    if (argc == 1) {
        int _v;
        {
            _v = SCM_STRINGP(argv[0]) ? 1 : 0;
        }
        if (_v) {
            return _wrap_read__SWIG_0(argc,argv);
        }
    }
    
    scm_misc_error("read", "No matching method for generic function `read'", SCM_EOL);
}


static SCM
_wrap_graph__SWIG_1 (int argc, SCM *argv)
{
#define FUNC_NAME "graph"
    Agraph_t *arg1 = (Agraph_t *) 0 ;
    char *arg2 ;
    Agraph_t *result;
    int must_free2 = 0 ;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agraph_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agraph_t, 1, 0);
    }
    {
        arg2 = SWIG_scm2str(argv[1]);
        must_free2 = 1;
    }
    gh_defer_ints();
    result = (Agraph_t *)graph(arg1,arg2);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agraph_t, 0);
    }
    if (must_free2 && arg2) SWIG_free(arg2);
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_graph(SCM rest)
{
    SCM argv[2];
    int argc = SWIG_Guile_GetArgs (argv, rest, 0, 2, "graph");
    if (argc == 1) {
        int _v;
        {
            _v = SCM_STRINGP(argv[0]) ? 1 : 0;
        }
        if (_v) {
            return _wrap_graph__SWIG_0(argc,argv);
        }
    }
    if (argc == 2) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agraph_t, 0);
        }
        if (_v) {
            {
                _v = SCM_STRINGP(argv[1]) ? 1 : 0;
            }
            if (_v) {
                return _wrap_graph__SWIG_1(argc,argv);
            }
        }
    }
    
    scm_misc_error("graph", "No matching method for generic function `graph'", SCM_EOL);
}


static SCM
_wrap_node (SCM s_0, SCM s_1)
{
#define FUNC_NAME "node"
    Agraph_t *arg1 = (Agraph_t *) 0 ;
    char *arg2 ;
    Agnode_t *result;
    int must_free2 = 0 ;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agraph_t *)SWIG_MustGetPtr(s_0, SWIGTYPE_p_Agraph_t, 1, 0);
    }
    {
        arg2 = SWIG_scm2str(s_1);
        must_free2 = 1;
    }
    gh_defer_ints();
    result = (Agnode_t *)node(arg1,arg2);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agnode_t, 0);
    }
    if (must_free2 && arg2) SWIG_free(arg2);
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_edge__SWIG_0 (int argc, SCM *argv)
{
#define FUNC_NAME "edge"
    Agnode_t *arg1 = (Agnode_t *) 0 ;
    Agnode_t *arg2 = (Agnode_t *) 0 ;
    Agedge_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agnode_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agnode_t, 1, 0);
    }
    {
        arg2 = (Agnode_t *)SWIG_MustGetPtr(argv[1], SWIGTYPE_p_Agnode_t, 2, 0);
    }
    gh_defer_ints();
    result = (Agedge_t *)edge(arg1,arg2);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agedge_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_edge__SWIG_1 (int argc, SCM *argv)
{
#define FUNC_NAME "edge"
    Agnode_t *arg1 = (Agnode_t *) 0 ;
    char *arg2 ;
    Agedge_t *result;
    int must_free2 = 0 ;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agnode_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agnode_t, 1, 0);
    }
    {
        arg2 = SWIG_scm2str(argv[1]);
        must_free2 = 1;
    }
    gh_defer_ints();
    result = (Agedge_t *)edge(arg1,arg2);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agedge_t, 0);
    }
    if (must_free2 && arg2) SWIG_free(arg2);
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_edge__SWIG_2 (int argc, SCM *argv)
{
#define FUNC_NAME "edge"
    char *arg1 ;
    Agnode_t *arg2 = (Agnode_t *) 0 ;
    Agedge_t *result;
    int must_free1 = 0 ;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = SWIG_scm2str(argv[0]);
        must_free1 = 1;
    }
    {
        arg2 = (Agnode_t *)SWIG_MustGetPtr(argv[1], SWIGTYPE_p_Agnode_t, 2, 0);
    }
    gh_defer_ints();
    result = (Agedge_t *)edge(arg1,arg2);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agedge_t, 0);
    }
    if (must_free1 && arg1) SWIG_free(arg1);
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_edge__SWIG_3 (int argc, SCM *argv)
{
#define FUNC_NAME "edge"
    Agraph_t *arg1 = (Agraph_t *) 0 ;
    char *arg2 ;
    char *arg3 ;
    Agedge_t *result;
    int must_free2 = 0 ;
    int must_free3 = 0 ;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agraph_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agraph_t, 1, 0);
    }
    {
        arg2 = SWIG_scm2str(argv[1]);
        must_free2 = 1;
    }
    {
        arg3 = SWIG_scm2str(argv[2]);
        must_free3 = 1;
    }
    gh_defer_ints();
    result = (Agedge_t *)edge(arg1,arg2,arg3);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agedge_t, 0);
    }
    if (must_free2 && arg2) SWIG_free(arg2);
    if (must_free3 && arg3) SWIG_free(arg3);
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_edge(SCM rest)
{
    SCM argv[3];
    int argc = SWIG_Guile_GetArgs (argv, rest, 0, 3, "edge");
    if (argc == 2) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agnode_t, 0);
        }
        if (_v) {
            {
                void *ptr;
                _v = !SWIG_ConvertPtr(argv[1], &ptr, SWIGTYPE_p_Agnode_t, 0);
            }
            if (_v) {
                return _wrap_edge__SWIG_0(argc,argv);
            }
        }
    }
    if (argc == 2) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agnode_t, 0);
        }
        if (_v) {
            {
                _v = SCM_STRINGP(argv[1]) ? 1 : 0;
            }
            if (_v) {
                return _wrap_edge__SWIG_1(argc,argv);
            }
        }
    }
    if (argc == 2) {
        int _v;
        {
            _v = SCM_STRINGP(argv[0]) ? 1 : 0;
        }
        if (_v) {
            {
                void *ptr;
                _v = !SWIG_ConvertPtr(argv[1], &ptr, SWIGTYPE_p_Agnode_t, 0);
            }
            if (_v) {
                return _wrap_edge__SWIG_2(argc,argv);
            }
        }
    }
    if (argc == 3) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agraph_t, 0);
        }
        if (_v) {
            {
                _v = SCM_STRINGP(argv[1]) ? 1 : 0;
            }
            if (_v) {
                {
                    _v = SCM_STRINGP(argv[2]) ? 1 : 0;
                }
                if (_v) {
                    return _wrap_edge__SWIG_3(argc,argv);
                }
            }
        }
    }
    
    scm_misc_error("edge", "No matching method for generic function `edge'", SCM_EOL);
}


static SCM
_wrap_setv__SWIG_0 (int argc, SCM *argv)
{
#define FUNC_NAME "setv"
    Agraph_t *arg1 = (Agraph_t *) 0 ;
    char *arg2 ;
    char *arg3 ;
    char *result;
    int must_free2 = 0 ;
    int must_free3 = 0 ;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agraph_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agraph_t, 1, 0);
    }
    {
        arg2 = SWIG_scm2str(argv[1]);
        must_free2 = 1;
    }
    {
        arg3 = SWIG_scm2str(argv[2]);
        must_free3 = 1;
    }
    gh_defer_ints();
    result = (char *)setv(arg1,arg2,arg3);
    
    gh_allow_ints();
    {
        gswig_result = gh_str02scm(result);
    }
    if (must_free2 && arg2) SWIG_free(arg2);
    if (must_free3 && arg3) SWIG_free(arg3);
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_setv__SWIG_1 (int argc, SCM *argv)
{
#define FUNC_NAME "setv"
    Agnode_t *arg1 = (Agnode_t *) 0 ;
    char *arg2 ;
    char *arg3 ;
    char *result;
    int must_free2 = 0 ;
    int must_free3 = 0 ;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agnode_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agnode_t, 1, 0);
    }
    {
        arg2 = SWIG_scm2str(argv[1]);
        must_free2 = 1;
    }
    {
        arg3 = SWIG_scm2str(argv[2]);
        must_free3 = 1;
    }
    gh_defer_ints();
    result = (char *)setv(arg1,arg2,arg3);
    
    gh_allow_ints();
    {
        gswig_result = gh_str02scm(result);
    }
    if (must_free2 && arg2) SWIG_free(arg2);
    if (must_free3 && arg3) SWIG_free(arg3);
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_setv__SWIG_2 (int argc, SCM *argv)
{
#define FUNC_NAME "setv"
    Agedge_t *arg1 = (Agedge_t *) 0 ;
    char *arg2 ;
    char *arg3 ;
    char *result;
    int must_free2 = 0 ;
    int must_free3 = 0 ;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agedge_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agedge_t, 1, 0);
    }
    {
        arg2 = SWIG_scm2str(argv[1]);
        must_free2 = 1;
    }
    {
        arg3 = SWIG_scm2str(argv[2]);
        must_free3 = 1;
    }
    gh_defer_ints();
    result = (char *)setv(arg1,arg2,arg3);
    
    gh_allow_ints();
    {
        gswig_result = gh_str02scm(result);
    }
    if (must_free2 && arg2) SWIG_free(arg2);
    if (must_free3 && arg3) SWIG_free(arg3);
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_setv__SWIG_3 (int argc, SCM *argv)
{
#define FUNC_NAME "setv"
    Agraph_t *arg1 = (Agraph_t *) 0 ;
    Agsym_t *arg2 = (Agsym_t *) 0 ;
    char *arg3 ;
    char *result;
    int must_free3 = 0 ;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agraph_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agraph_t, 1, 0);
    }
    {
        arg2 = (Agsym_t *)SWIG_MustGetPtr(argv[1], SWIGTYPE_p_Agsym_t, 2, 0);
    }
    {
        arg3 = SWIG_scm2str(argv[2]);
        must_free3 = 1;
    }
    gh_defer_ints();
    result = (char *)setv(arg1,arg2,arg3);
    
    gh_allow_ints();
    {
        gswig_result = gh_str02scm(result);
    }
    if (must_free3 && arg3) SWIG_free(arg3);
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_setv__SWIG_4 (int argc, SCM *argv)
{
#define FUNC_NAME "setv"
    Agnode_t *arg1 = (Agnode_t *) 0 ;
    Agsym_t *arg2 = (Agsym_t *) 0 ;
    char *arg3 ;
    char *result;
    int must_free3 = 0 ;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agnode_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agnode_t, 1, 0);
    }
    {
        arg2 = (Agsym_t *)SWIG_MustGetPtr(argv[1], SWIGTYPE_p_Agsym_t, 2, 0);
    }
    {
        arg3 = SWIG_scm2str(argv[2]);
        must_free3 = 1;
    }
    gh_defer_ints();
    result = (char *)setv(arg1,arg2,arg3);
    
    gh_allow_ints();
    {
        gswig_result = gh_str02scm(result);
    }
    if (must_free3 && arg3) SWIG_free(arg3);
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_setv__SWIG_5 (int argc, SCM *argv)
{
#define FUNC_NAME "setv"
    Agedge_t *arg1 = (Agedge_t *) 0 ;
    Agsym_t *arg2 = (Agsym_t *) 0 ;
    char *arg3 ;
    char *result;
    int must_free3 = 0 ;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agedge_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agedge_t, 1, 0);
    }
    {
        arg2 = (Agsym_t *)SWIG_MustGetPtr(argv[1], SWIGTYPE_p_Agsym_t, 2, 0);
    }
    {
        arg3 = SWIG_scm2str(argv[2]);
        must_free3 = 1;
    }
    gh_defer_ints();
    result = (char *)setv(arg1,arg2,arg3);
    
    gh_allow_ints();
    {
        gswig_result = gh_str02scm(result);
    }
    if (must_free3 && arg3) SWIG_free(arg3);
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_setv(SCM rest)
{
    SCM argv[3];
    int argc = SWIG_Guile_GetArgs (argv, rest, 0, 3, "setv");
    if (argc == 3) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agraph_t, 0);
        }
        if (_v) {
            {
                void *ptr;
                _v = !SWIG_ConvertPtr(argv[1], &ptr, SWIGTYPE_p_Agsym_t, 0);
            }
            if (_v) {
                {
                    _v = SCM_STRINGP(argv[2]) ? 1 : 0;
                }
                if (_v) {
                    return _wrap_setv__SWIG_3(argc,argv);
                }
            }
        }
    }
    if (argc == 3) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agnode_t, 0);
        }
        if (_v) {
            {
                void *ptr;
                _v = !SWIG_ConvertPtr(argv[1], &ptr, SWIGTYPE_p_Agsym_t, 0);
            }
            if (_v) {
                {
                    _v = SCM_STRINGP(argv[2]) ? 1 : 0;
                }
                if (_v) {
                    return _wrap_setv__SWIG_4(argc,argv);
                }
            }
        }
    }
    if (argc == 3) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agedge_t, 0);
        }
        if (_v) {
            {
                void *ptr;
                _v = !SWIG_ConvertPtr(argv[1], &ptr, SWIGTYPE_p_Agsym_t, 0);
            }
            if (_v) {
                {
                    _v = SCM_STRINGP(argv[2]) ? 1 : 0;
                }
                if (_v) {
                    return _wrap_setv__SWIG_5(argc,argv);
                }
            }
        }
    }
    if (argc == 3) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agraph_t, 0);
        }
        if (_v) {
            {
                _v = SCM_STRINGP(argv[1]) ? 1 : 0;
            }
            if (_v) {
                {
                    _v = SCM_STRINGP(argv[2]) ? 1 : 0;
                }
                if (_v) {
                    return _wrap_setv__SWIG_0(argc,argv);
                }
            }
        }
    }
    if (argc == 3) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agnode_t, 0);
        }
        if (_v) {
            {
                _v = SCM_STRINGP(argv[1]) ? 1 : 0;
            }
            if (_v) {
                {
                    _v = SCM_STRINGP(argv[2]) ? 1 : 0;
                }
                if (_v) {
                    return _wrap_setv__SWIG_1(argc,argv);
                }
            }
        }
    }
    if (argc == 3) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agedge_t, 0);
        }
        if (_v) {
            {
                _v = SCM_STRINGP(argv[1]) ? 1 : 0;
            }
            if (_v) {
                {
                    _v = SCM_STRINGP(argv[2]) ? 1 : 0;
                }
                if (_v) {
                    return _wrap_setv__SWIG_2(argc,argv);
                }
            }
        }
    }
    
    scm_misc_error("setv", "No matching method for generic function `setv'", SCM_EOL);
}


static SCM
_wrap_getv__SWIG_0 (int argc, SCM *argv)
{
#define FUNC_NAME "getv"
    Agraph_t *arg1 = (Agraph_t *) 0 ;
    char *arg2 ;
    char *result;
    int must_free2 = 0 ;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agraph_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agraph_t, 1, 0);
    }
    {
        arg2 = SWIG_scm2str(argv[1]);
        must_free2 = 1;
    }
    gh_defer_ints();
    result = (char *)getv(arg1,arg2);
    
    gh_allow_ints();
    {
        gswig_result = gh_str02scm(result);
    }
    if (must_free2 && arg2) SWIG_free(arg2);
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_getv__SWIG_1 (int argc, SCM *argv)
{
#define FUNC_NAME "getv"
    Agnode_t *arg1 = (Agnode_t *) 0 ;
    char *arg2 ;
    char *result;
    int must_free2 = 0 ;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agnode_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agnode_t, 1, 0);
    }
    {
        arg2 = SWIG_scm2str(argv[1]);
        must_free2 = 1;
    }
    gh_defer_ints();
    result = (char *)getv(arg1,arg2);
    
    gh_allow_ints();
    {
        gswig_result = gh_str02scm(result);
    }
    if (must_free2 && arg2) SWIG_free(arg2);
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_getv__SWIG_2 (int argc, SCM *argv)
{
#define FUNC_NAME "getv"
    Agedge_t *arg1 = (Agedge_t *) 0 ;
    char *arg2 ;
    char *result;
    int must_free2 = 0 ;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agedge_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agedge_t, 1, 0);
    }
    {
        arg2 = SWIG_scm2str(argv[1]);
        must_free2 = 1;
    }
    gh_defer_ints();
    result = (char *)getv(arg1,arg2);
    
    gh_allow_ints();
    {
        gswig_result = gh_str02scm(result);
    }
    if (must_free2 && arg2) SWIG_free(arg2);
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_getv__SWIG_3 (int argc, SCM *argv)
{
#define FUNC_NAME "getv"
    Agraph_t *arg1 = (Agraph_t *) 0 ;
    Agsym_t *arg2 = (Agsym_t *) 0 ;
    char *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agraph_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agraph_t, 1, 0);
    }
    {
        arg2 = (Agsym_t *)SWIG_MustGetPtr(argv[1], SWIGTYPE_p_Agsym_t, 2, 0);
    }
    gh_defer_ints();
    result = (char *)getv(arg1,arg2);
    
    gh_allow_ints();
    {
        gswig_result = gh_str02scm(result);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_getv__SWIG_4 (int argc, SCM *argv)
{
#define FUNC_NAME "getv"
    Agnode_t *arg1 = (Agnode_t *) 0 ;
    Agsym_t *arg2 = (Agsym_t *) 0 ;
    char *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agnode_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agnode_t, 1, 0);
    }
    {
        arg2 = (Agsym_t *)SWIG_MustGetPtr(argv[1], SWIGTYPE_p_Agsym_t, 2, 0);
    }
    gh_defer_ints();
    result = (char *)getv(arg1,arg2);
    
    gh_allow_ints();
    {
        gswig_result = gh_str02scm(result);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_getv__SWIG_5 (int argc, SCM *argv)
{
#define FUNC_NAME "getv"
    Agedge_t *arg1 = (Agedge_t *) 0 ;
    Agsym_t *arg2 = (Agsym_t *) 0 ;
    char *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agedge_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agedge_t, 1, 0);
    }
    {
        arg2 = (Agsym_t *)SWIG_MustGetPtr(argv[1], SWIGTYPE_p_Agsym_t, 2, 0);
    }
    gh_defer_ints();
    result = (char *)getv(arg1,arg2);
    
    gh_allow_ints();
    {
        gswig_result = gh_str02scm(result);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_getv(SCM rest)
{
    SCM argv[2];
    int argc = SWIG_Guile_GetArgs (argv, rest, 0, 2, "getv");
    if (argc == 2) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agraph_t, 0);
        }
        if (_v) {
            {
                void *ptr;
                _v = !SWIG_ConvertPtr(argv[1], &ptr, SWIGTYPE_p_Agsym_t, 0);
            }
            if (_v) {
                return _wrap_getv__SWIG_3(argc,argv);
            }
        }
    }
    if (argc == 2) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agnode_t, 0);
        }
        if (_v) {
            {
                void *ptr;
                _v = !SWIG_ConvertPtr(argv[1], &ptr, SWIGTYPE_p_Agsym_t, 0);
            }
            if (_v) {
                return _wrap_getv__SWIG_4(argc,argv);
            }
        }
    }
    if (argc == 2) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agedge_t, 0);
        }
        if (_v) {
            {
                void *ptr;
                _v = !SWIG_ConvertPtr(argv[1], &ptr, SWIGTYPE_p_Agsym_t, 0);
            }
            if (_v) {
                return _wrap_getv__SWIG_5(argc,argv);
            }
        }
    }
    if (argc == 2) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agraph_t, 0);
        }
        if (_v) {
            {
                _v = SCM_STRINGP(argv[1]) ? 1 : 0;
            }
            if (_v) {
                return _wrap_getv__SWIG_0(argc,argv);
            }
        }
    }
    if (argc == 2) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agnode_t, 0);
        }
        if (_v) {
            {
                _v = SCM_STRINGP(argv[1]) ? 1 : 0;
            }
            if (_v) {
                return _wrap_getv__SWIG_1(argc,argv);
            }
        }
    }
    if (argc == 2) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agedge_t, 0);
        }
        if (_v) {
            {
                _v = SCM_STRINGP(argv[1]) ? 1 : 0;
            }
            if (_v) {
                return _wrap_getv__SWIG_2(argc,argv);
            }
        }
    }
    
    scm_misc_error("getv", "No matching method for generic function `getv'", SCM_EOL);
}


static SCM
_wrap_nameof__SWIG_0 (int argc, SCM *argv)
{
#define FUNC_NAME "nameof"
    Agraph_t *arg1 = (Agraph_t *) 0 ;
    char *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agraph_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agraph_t, 1, 0);
    }
    gh_defer_ints();
    result = (char *)nameof(arg1);
    
    gh_allow_ints();
    {
        gswig_result = gh_str02scm(result);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_nameof__SWIG_1 (int argc, SCM *argv)
{
#define FUNC_NAME "nameof"
    Agnode_t *arg1 = (Agnode_t *) 0 ;
    char *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agnode_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agnode_t, 1, 0);
    }
    gh_defer_ints();
    result = (char *)nameof(arg1);
    
    gh_allow_ints();
    {
        gswig_result = gh_str02scm(result);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_nameof__SWIG_2 (int argc, SCM *argv)
{
#define FUNC_NAME "nameof"
    Agsym_t *arg1 = (Agsym_t *) 0 ;
    char *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agsym_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agsym_t, 1, 0);
    }
    gh_defer_ints();
    result = (char *)nameof(arg1);
    
    gh_allow_ints();
    {
        gswig_result = gh_str02scm(result);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_nameof(SCM rest)
{
    SCM argv[1];
    int argc = SWIG_Guile_GetArgs (argv, rest, 0, 1, "nameof");
    if (argc == 1) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agraph_t, 0);
        }
        if (_v) {
            return _wrap_nameof__SWIG_0(argc,argv);
        }
    }
    if (argc == 1) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agnode_t, 0);
        }
        if (_v) {
            return _wrap_nameof__SWIG_1(argc,argv);
        }
    }
    if (argc == 1) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agsym_t, 0);
        }
        if (_v) {
            return _wrap_nameof__SWIG_2(argc,argv);
        }
    }
    
    scm_misc_error("nameof", "No matching method for generic function `nameof'", SCM_EOL);
}


static SCM
_wrap_findsubg (SCM s_0, SCM s_1)
{
#define FUNC_NAME "findsubg"
    Agraph_t *arg1 = (Agraph_t *) 0 ;
    char *arg2 ;
    Agraph_t *result;
    int must_free2 = 0 ;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agraph_t *)SWIG_MustGetPtr(s_0, SWIGTYPE_p_Agraph_t, 1, 0);
    }
    {
        arg2 = SWIG_scm2str(s_1);
        must_free2 = 1;
    }
    gh_defer_ints();
    result = (Agraph_t *)findsubg(arg1,arg2);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agraph_t, 0);
    }
    if (must_free2 && arg2) SWIG_free(arg2);
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_findnode (SCM s_0, SCM s_1)
{
#define FUNC_NAME "findnode"
    Agraph_t *arg1 = (Agraph_t *) 0 ;
    char *arg2 ;
    Agnode_t *result;
    int must_free2 = 0 ;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agraph_t *)SWIG_MustGetPtr(s_0, SWIGTYPE_p_Agraph_t, 1, 0);
    }
    {
        arg2 = SWIG_scm2str(s_1);
        must_free2 = 1;
    }
    gh_defer_ints();
    result = (Agnode_t *)findnode(arg1,arg2);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agnode_t, 0);
    }
    if (must_free2 && arg2) SWIG_free(arg2);
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_findedge (SCM s_0, SCM s_1)
{
#define FUNC_NAME "findedge"
    Agnode_t *arg1 = (Agnode_t *) 0 ;
    Agnode_t *arg2 = (Agnode_t *) 0 ;
    Agedge_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agnode_t *)SWIG_MustGetPtr(s_0, SWIGTYPE_p_Agnode_t, 1, 0);
    }
    {
        arg2 = (Agnode_t *)SWIG_MustGetPtr(s_1, SWIGTYPE_p_Agnode_t, 2, 0);
    }
    gh_defer_ints();
    result = (Agedge_t *)findedge(arg1,arg2);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agedge_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_findattr__SWIG_0 (int argc, SCM *argv)
{
#define FUNC_NAME "findattr"
    Agraph_t *arg1 = (Agraph_t *) 0 ;
    char *arg2 ;
    Agsym_t *result;
    int must_free2 = 0 ;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agraph_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agraph_t, 1, 0);
    }
    {
        arg2 = SWIG_scm2str(argv[1]);
        must_free2 = 1;
    }
    gh_defer_ints();
    result = (Agsym_t *)findattr(arg1,arg2);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agsym_t, 0);
    }
    if (must_free2 && arg2) SWIG_free(arg2);
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_findattr__SWIG_1 (int argc, SCM *argv)
{
#define FUNC_NAME "findattr"
    Agnode_t *arg1 = (Agnode_t *) 0 ;
    char *arg2 ;
    Agsym_t *result;
    int must_free2 = 0 ;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agnode_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agnode_t, 1, 0);
    }
    {
        arg2 = SWIG_scm2str(argv[1]);
        must_free2 = 1;
    }
    gh_defer_ints();
    result = (Agsym_t *)findattr(arg1,arg2);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agsym_t, 0);
    }
    if (must_free2 && arg2) SWIG_free(arg2);
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_findattr__SWIG_2 (int argc, SCM *argv)
{
#define FUNC_NAME "findattr"
    Agedge_t *arg1 = (Agedge_t *) 0 ;
    char *arg2 ;
    Agsym_t *result;
    int must_free2 = 0 ;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agedge_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agedge_t, 1, 0);
    }
    {
        arg2 = SWIG_scm2str(argv[1]);
        must_free2 = 1;
    }
    gh_defer_ints();
    result = (Agsym_t *)findattr(arg1,arg2);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agsym_t, 0);
    }
    if (must_free2 && arg2) SWIG_free(arg2);
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_findattr(SCM rest)
{
    SCM argv[2];
    int argc = SWIG_Guile_GetArgs (argv, rest, 0, 2, "findattr");
    if (argc == 2) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agraph_t, 0);
        }
        if (_v) {
            {
                _v = SCM_STRINGP(argv[1]) ? 1 : 0;
            }
            if (_v) {
                return _wrap_findattr__SWIG_0(argc,argv);
            }
        }
    }
    if (argc == 2) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agnode_t, 0);
        }
        if (_v) {
            {
                _v = SCM_STRINGP(argv[1]) ? 1 : 0;
            }
            if (_v) {
                return _wrap_findattr__SWIG_1(argc,argv);
            }
        }
    }
    if (argc == 2) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agedge_t, 0);
        }
        if (_v) {
            {
                _v = SCM_STRINGP(argv[1]) ? 1 : 0;
            }
            if (_v) {
                return _wrap_findattr__SWIG_2(argc,argv);
            }
        }
    }
    
    scm_misc_error("findattr", "No matching method for generic function `findattr'", SCM_EOL);
}


static SCM
_wrap_headof (SCM s_0)
{
#define FUNC_NAME "headof"
    Agedge_t *arg1 = (Agedge_t *) 0 ;
    Agnode_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agedge_t *)SWIG_MustGetPtr(s_0, SWIGTYPE_p_Agedge_t, 1, 0);
    }
    gh_defer_ints();
    result = (Agnode_t *)headof(arg1);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agnode_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_tailof (SCM s_0)
{
#define FUNC_NAME "tailof"
    Agedge_t *arg1 = (Agedge_t *) 0 ;
    Agnode_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agedge_t *)SWIG_MustGetPtr(s_0, SWIGTYPE_p_Agedge_t, 1, 0);
    }
    gh_defer_ints();
    result = (Agnode_t *)tailof(arg1);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agnode_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_graphof__SWIG_0 (int argc, SCM *argv)
{
#define FUNC_NAME "graphof"
    Agraph_t *arg1 = (Agraph_t *) 0 ;
    Agraph_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agraph_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agraph_t, 1, 0);
    }
    gh_defer_ints();
    result = (Agraph_t *)graphof(arg1);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agraph_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_graphof__SWIG_1 (int argc, SCM *argv)
{
#define FUNC_NAME "graphof"
    Agedge_t *arg1 = (Agedge_t *) 0 ;
    Agraph_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agedge_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agedge_t, 1, 0);
    }
    gh_defer_ints();
    result = (Agraph_t *)graphof(arg1);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agraph_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_graphof__SWIG_2 (int argc, SCM *argv)
{
#define FUNC_NAME "graphof"
    Agnode_t *arg1 = (Agnode_t *) 0 ;
    Agraph_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agnode_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agnode_t, 1, 0);
    }
    gh_defer_ints();
    result = (Agraph_t *)graphof(arg1);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agraph_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_graphof(SCM rest)
{
    SCM argv[1];
    int argc = SWIG_Guile_GetArgs (argv, rest, 0, 1, "graphof");
    if (argc == 1) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agraph_t, 0);
        }
        if (_v) {
            return _wrap_graphof__SWIG_0(argc,argv);
        }
    }
    if (argc == 1) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agedge_t, 0);
        }
        if (_v) {
            return _wrap_graphof__SWIG_1(argc,argv);
        }
    }
    if (argc == 1) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agnode_t, 0);
        }
        if (_v) {
            return _wrap_graphof__SWIG_2(argc,argv);
        }
    }
    
    scm_misc_error("graphof", "No matching method for generic function `graphof'", SCM_EOL);
}


static SCM
_wrap_rootof (SCM s_0)
{
#define FUNC_NAME "rootof"
    Agraph_t *arg1 = (Agraph_t *) 0 ;
    Agraph_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agraph_t *)SWIG_MustGetPtr(s_0, SWIGTYPE_p_Agraph_t, 1, 0);
    }
    gh_defer_ints();
    result = (Agraph_t *)rootof(arg1);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agraph_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_protonode (SCM s_0)
{
#define FUNC_NAME "protonode"
    Agraph_t *arg1 = (Agraph_t *) 0 ;
    Agnode_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agraph_t *)SWIG_MustGetPtr(s_0, SWIGTYPE_p_Agraph_t, 1, 0);
    }
    gh_defer_ints();
    result = (Agnode_t *)protonode(arg1);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agnode_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_protoedge (SCM s_0)
{
#define FUNC_NAME "protoedge"
    Agraph_t *arg1 = (Agraph_t *) 0 ;
    Agedge_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agraph_t *)SWIG_MustGetPtr(s_0, SWIGTYPE_p_Agraph_t, 1, 0);
    }
    gh_defer_ints();
    result = (Agedge_t *)protoedge(arg1);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agedge_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_ok__SWIG_0 (int argc, SCM *argv)
{
#define FUNC_NAME "ok"
    Agraph_t *arg1 = (Agraph_t *) 0 ;
    bool result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agraph_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agraph_t, 1, 0);
    }
    gh_defer_ints();
    result = (bool)ok(arg1);
    
    gh_allow_ints();
    {
        gswig_result = gh_bool2scm(result);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_ok__SWIG_1 (int argc, SCM *argv)
{
#define FUNC_NAME "ok"
    Agnode_t *arg1 = (Agnode_t *) 0 ;
    bool result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agnode_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agnode_t, 1, 0);
    }
    gh_defer_ints();
    result = (bool)ok(arg1);
    
    gh_allow_ints();
    {
        gswig_result = gh_bool2scm(result);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_ok__SWIG_2 (int argc, SCM *argv)
{
#define FUNC_NAME "ok"
    Agedge_t *arg1 = (Agedge_t *) 0 ;
    bool result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agedge_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agedge_t, 1, 0);
    }
    gh_defer_ints();
    result = (bool)ok(arg1);
    
    gh_allow_ints();
    {
        gswig_result = gh_bool2scm(result);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_ok__SWIG_3 (int argc, SCM *argv)
{
#define FUNC_NAME "ok"
    Agsym_t *arg1 = (Agsym_t *) 0 ;
    bool result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agsym_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agsym_t, 1, 0);
    }
    gh_defer_ints();
    result = (bool)ok(arg1);
    
    gh_allow_ints();
    {
        gswig_result = gh_bool2scm(result);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_ok(SCM rest)
{
    SCM argv[1];
    int argc = SWIG_Guile_GetArgs (argv, rest, 0, 1, "ok");
    if (argc == 1) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agraph_t, 0);
        }
        if (_v) {
            return _wrap_ok__SWIG_0(argc,argv);
        }
    }
    if (argc == 1) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agnode_t, 0);
        }
        if (_v) {
            return _wrap_ok__SWIG_1(argc,argv);
        }
    }
    if (argc == 1) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agedge_t, 0);
        }
        if (_v) {
            return _wrap_ok__SWIG_2(argc,argv);
        }
    }
    if (argc == 1) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agsym_t, 0);
        }
        if (_v) {
            return _wrap_ok__SWIG_3(argc,argv);
        }
    }
    
    scm_misc_error("ok", "No matching method for generic function `ok'", SCM_EOL);
}


static SCM
_wrap_firstsubg (SCM s_0)
{
#define FUNC_NAME "firstsubg"
    Agraph_t *arg1 = (Agraph_t *) 0 ;
    Agraph_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agraph_t *)SWIG_MustGetPtr(s_0, SWIGTYPE_p_Agraph_t, 1, 0);
    }
    gh_defer_ints();
    result = (Agraph_t *)firstsubg(arg1);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agraph_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_nextsubg (SCM s_0, SCM s_1)
{
#define FUNC_NAME "nextsubg"
    Agraph_t *arg1 = (Agraph_t *) 0 ;
    Agraph_t *arg2 = (Agraph_t *) 0 ;
    Agraph_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agraph_t *)SWIG_MustGetPtr(s_0, SWIGTYPE_p_Agraph_t, 1, 0);
    }
    {
        arg2 = (Agraph_t *)SWIG_MustGetPtr(s_1, SWIGTYPE_p_Agraph_t, 2, 0);
    }
    gh_defer_ints();
    result = (Agraph_t *)nextsubg(arg1,arg2);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agraph_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_firstsupg (SCM s_0)
{
#define FUNC_NAME "firstsupg"
    Agraph_t *arg1 = (Agraph_t *) 0 ;
    Agraph_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agraph_t *)SWIG_MustGetPtr(s_0, SWIGTYPE_p_Agraph_t, 1, 0);
    }
    gh_defer_ints();
    result = (Agraph_t *)firstsupg(arg1);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agraph_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_nextsupg (SCM s_0, SCM s_1)
{
#define FUNC_NAME "nextsupg"
    Agraph_t *arg1 = (Agraph_t *) 0 ;
    Agraph_t *arg2 = (Agraph_t *) 0 ;
    Agraph_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agraph_t *)SWIG_MustGetPtr(s_0, SWIGTYPE_p_Agraph_t, 1, 0);
    }
    {
        arg2 = (Agraph_t *)SWIG_MustGetPtr(s_1, SWIGTYPE_p_Agraph_t, 2, 0);
    }
    gh_defer_ints();
    result = (Agraph_t *)nextsupg(arg1,arg2);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agraph_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_firstedge__SWIG_0 (int argc, SCM *argv)
{
#define FUNC_NAME "firstedge"
    Agraph_t *arg1 = (Agraph_t *) 0 ;
    Agedge_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agraph_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agraph_t, 1, 0);
    }
    gh_defer_ints();
    result = (Agedge_t *)firstedge(arg1);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agedge_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_nextedge__SWIG_0 (int argc, SCM *argv)
{
#define FUNC_NAME "nextedge"
    Agraph_t *arg1 = (Agraph_t *) 0 ;
    Agedge_t *arg2 = (Agedge_t *) 0 ;
    Agedge_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agraph_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agraph_t, 1, 0);
    }
    {
        arg2 = (Agedge_t *)SWIG_MustGetPtr(argv[1], SWIGTYPE_p_Agedge_t, 2, 0);
    }
    gh_defer_ints();
    result = (Agedge_t *)nextedge(arg1,arg2);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agedge_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_firstout__SWIG_0 (int argc, SCM *argv)
{
#define FUNC_NAME "firstout"
    Agraph_t *arg1 = (Agraph_t *) 0 ;
    Agedge_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agraph_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agraph_t, 1, 0);
    }
    gh_defer_ints();
    result = (Agedge_t *)firstout(arg1);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agedge_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_nextout__SWIG_0 (int argc, SCM *argv)
{
#define FUNC_NAME "nextout"
    Agraph_t *arg1 = (Agraph_t *) 0 ;
    Agedge_t *arg2 = (Agedge_t *) 0 ;
    Agedge_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agraph_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agraph_t, 1, 0);
    }
    {
        arg2 = (Agedge_t *)SWIG_MustGetPtr(argv[1], SWIGTYPE_p_Agedge_t, 2, 0);
    }
    gh_defer_ints();
    result = (Agedge_t *)nextout(arg1,arg2);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agedge_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_firstedge__SWIG_1 (int argc, SCM *argv)
{
#define FUNC_NAME "firstedge"
    Agnode_t *arg1 = (Agnode_t *) 0 ;
    Agedge_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agnode_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agnode_t, 1, 0);
    }
    gh_defer_ints();
    result = (Agedge_t *)firstedge(arg1);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agedge_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_firstedge(SCM rest)
{
    SCM argv[1];
    int argc = SWIG_Guile_GetArgs (argv, rest, 0, 1, "firstedge");
    if (argc == 1) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agraph_t, 0);
        }
        if (_v) {
            return _wrap_firstedge__SWIG_0(argc,argv);
        }
    }
    if (argc == 1) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agnode_t, 0);
        }
        if (_v) {
            return _wrap_firstedge__SWIG_1(argc,argv);
        }
    }
    
    scm_misc_error("firstedge", "No matching method for generic function `firstedge'", SCM_EOL);
}


static SCM
_wrap_nextedge__SWIG_1 (int argc, SCM *argv)
{
#define FUNC_NAME "nextedge"
    Agnode_t *arg1 = (Agnode_t *) 0 ;
    Agedge_t *arg2 = (Agedge_t *) 0 ;
    Agedge_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agnode_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agnode_t, 1, 0);
    }
    {
        arg2 = (Agedge_t *)SWIG_MustGetPtr(argv[1], SWIGTYPE_p_Agedge_t, 2, 0);
    }
    gh_defer_ints();
    result = (Agedge_t *)nextedge(arg1,arg2);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agedge_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_nextedge(SCM rest)
{
    SCM argv[2];
    int argc = SWIG_Guile_GetArgs (argv, rest, 0, 2, "nextedge");
    if (argc == 2) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agraph_t, 0);
        }
        if (_v) {
            {
                void *ptr;
                _v = !SWIG_ConvertPtr(argv[1], &ptr, SWIGTYPE_p_Agedge_t, 0);
            }
            if (_v) {
                return _wrap_nextedge__SWIG_0(argc,argv);
            }
        }
    }
    if (argc == 2) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agnode_t, 0);
        }
        if (_v) {
            {
                void *ptr;
                _v = !SWIG_ConvertPtr(argv[1], &ptr, SWIGTYPE_p_Agedge_t, 0);
            }
            if (_v) {
                return _wrap_nextedge__SWIG_1(argc,argv);
            }
        }
    }
    
    scm_misc_error("nextedge", "No matching method for generic function `nextedge'", SCM_EOL);
}


static SCM
_wrap_firstout__SWIG_1 (int argc, SCM *argv)
{
#define FUNC_NAME "firstout"
    Agnode_t *arg1 = (Agnode_t *) 0 ;
    Agedge_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agnode_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agnode_t, 1, 0);
    }
    gh_defer_ints();
    result = (Agedge_t *)firstout(arg1);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agedge_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_firstout(SCM rest)
{
    SCM argv[1];
    int argc = SWIG_Guile_GetArgs (argv, rest, 0, 1, "firstout");
    if (argc == 1) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agraph_t, 0);
        }
        if (_v) {
            return _wrap_firstout__SWIG_0(argc,argv);
        }
    }
    if (argc == 1) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agnode_t, 0);
        }
        if (_v) {
            return _wrap_firstout__SWIG_1(argc,argv);
        }
    }
    
    scm_misc_error("firstout", "No matching method for generic function `firstout'", SCM_EOL);
}


static SCM
_wrap_nextout__SWIG_1 (int argc, SCM *argv)
{
#define FUNC_NAME "nextout"
    Agnode_t *arg1 = (Agnode_t *) 0 ;
    Agedge_t *arg2 = (Agedge_t *) 0 ;
    Agedge_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agnode_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agnode_t, 1, 0);
    }
    {
        arg2 = (Agedge_t *)SWIG_MustGetPtr(argv[1], SWIGTYPE_p_Agedge_t, 2, 0);
    }
    gh_defer_ints();
    result = (Agedge_t *)nextout(arg1,arg2);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agedge_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_nextout(SCM rest)
{
    SCM argv[2];
    int argc = SWIG_Guile_GetArgs (argv, rest, 0, 2, "nextout");
    if (argc == 2) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agraph_t, 0);
        }
        if (_v) {
            {
                void *ptr;
                _v = !SWIG_ConvertPtr(argv[1], &ptr, SWIGTYPE_p_Agedge_t, 0);
            }
            if (_v) {
                return _wrap_nextout__SWIG_0(argc,argv);
            }
        }
    }
    if (argc == 2) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agnode_t, 0);
        }
        if (_v) {
            {
                void *ptr;
                _v = !SWIG_ConvertPtr(argv[1], &ptr, SWIGTYPE_p_Agedge_t, 0);
            }
            if (_v) {
                return _wrap_nextout__SWIG_1(argc,argv);
            }
        }
    }
    
    scm_misc_error("nextout", "No matching method for generic function `nextout'", SCM_EOL);
}


static SCM
_wrap_firsthead (SCM s_0)
{
#define FUNC_NAME "firsthead"
    Agnode_t *arg1 = (Agnode_t *) 0 ;
    Agnode_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agnode_t *)SWIG_MustGetPtr(s_0, SWIGTYPE_p_Agnode_t, 1, 0);
    }
    gh_defer_ints();
    result = (Agnode_t *)firsthead(arg1);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agnode_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_nexthead (SCM s_0, SCM s_1)
{
#define FUNC_NAME "nexthead"
    Agnode_t *arg1 = (Agnode_t *) 0 ;
    Agnode_t *arg2 = (Agnode_t *) 0 ;
    Agnode_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agnode_t *)SWIG_MustGetPtr(s_0, SWIGTYPE_p_Agnode_t, 1, 0);
    }
    {
        arg2 = (Agnode_t *)SWIG_MustGetPtr(s_1, SWIGTYPE_p_Agnode_t, 2, 0);
    }
    gh_defer_ints();
    result = (Agnode_t *)nexthead(arg1,arg2);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agnode_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_firstin__SWIG_0 (int argc, SCM *argv)
{
#define FUNC_NAME "firstin"
    Agraph_t *arg1 = (Agraph_t *) 0 ;
    Agedge_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agraph_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agraph_t, 1, 0);
    }
    gh_defer_ints();
    result = (Agedge_t *)firstin(arg1);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agedge_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_nextin__SWIG_0 (int argc, SCM *argv)
{
#define FUNC_NAME "nextin"
    Agnode_t *arg1 = (Agnode_t *) 0 ;
    Agedge_t *arg2 = (Agedge_t *) 0 ;
    Agedge_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agnode_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agnode_t, 1, 0);
    }
    {
        arg2 = (Agedge_t *)SWIG_MustGetPtr(argv[1], SWIGTYPE_p_Agedge_t, 2, 0);
    }
    gh_defer_ints();
    result = (Agedge_t *)nextin(arg1,arg2);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agedge_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_firstin__SWIG_1 (int argc, SCM *argv)
{
#define FUNC_NAME "firstin"
    Agnode_t *arg1 = (Agnode_t *) 0 ;
    Agedge_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agnode_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agnode_t, 1, 0);
    }
    gh_defer_ints();
    result = (Agedge_t *)firstin(arg1);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agedge_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_firstin(SCM rest)
{
    SCM argv[1];
    int argc = SWIG_Guile_GetArgs (argv, rest, 0, 1, "firstin");
    if (argc == 1) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agraph_t, 0);
        }
        if (_v) {
            return _wrap_firstin__SWIG_0(argc,argv);
        }
    }
    if (argc == 1) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agnode_t, 0);
        }
        if (_v) {
            return _wrap_firstin__SWIG_1(argc,argv);
        }
    }
    
    scm_misc_error("firstin", "No matching method for generic function `firstin'", SCM_EOL);
}


static SCM
_wrap_nextin__SWIG_1 (int argc, SCM *argv)
{
#define FUNC_NAME "nextin"
    Agraph_t *arg1 = (Agraph_t *) 0 ;
    Agedge_t *arg2 = (Agedge_t *) 0 ;
    Agedge_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agraph_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agraph_t, 1, 0);
    }
    {
        arg2 = (Agedge_t *)SWIG_MustGetPtr(argv[1], SWIGTYPE_p_Agedge_t, 2, 0);
    }
    gh_defer_ints();
    result = (Agedge_t *)nextin(arg1,arg2);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agedge_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_nextin(SCM rest)
{
    SCM argv[2];
    int argc = SWIG_Guile_GetArgs (argv, rest, 0, 2, "nextin");
    if (argc == 2) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agnode_t, 0);
        }
        if (_v) {
            {
                void *ptr;
                _v = !SWIG_ConvertPtr(argv[1], &ptr, SWIGTYPE_p_Agedge_t, 0);
            }
            if (_v) {
                return _wrap_nextin__SWIG_0(argc,argv);
            }
        }
    }
    if (argc == 2) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agraph_t, 0);
        }
        if (_v) {
            {
                void *ptr;
                _v = !SWIG_ConvertPtr(argv[1], &ptr, SWIGTYPE_p_Agedge_t, 0);
            }
            if (_v) {
                return _wrap_nextin__SWIG_1(argc,argv);
            }
        }
    }
    
    scm_misc_error("nextin", "No matching method for generic function `nextin'", SCM_EOL);
}


static SCM
_wrap_firsttail (SCM s_0)
{
#define FUNC_NAME "firsttail"
    Agnode_t *arg1 = (Agnode_t *) 0 ;
    Agnode_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agnode_t *)SWIG_MustGetPtr(s_0, SWIGTYPE_p_Agnode_t, 1, 0);
    }
    gh_defer_ints();
    result = (Agnode_t *)firsttail(arg1);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agnode_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_nexttail (SCM s_0, SCM s_1)
{
#define FUNC_NAME "nexttail"
    Agnode_t *arg1 = (Agnode_t *) 0 ;
    Agnode_t *arg2 = (Agnode_t *) 0 ;
    Agnode_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agnode_t *)SWIG_MustGetPtr(s_0, SWIGTYPE_p_Agnode_t, 1, 0);
    }
    {
        arg2 = (Agnode_t *)SWIG_MustGetPtr(s_1, SWIGTYPE_p_Agnode_t, 2, 0);
    }
    gh_defer_ints();
    result = (Agnode_t *)nexttail(arg1,arg2);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agnode_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_firstnode__SWIG_0 (int argc, SCM *argv)
{
#define FUNC_NAME "firstnode"
    Agraph_t *arg1 = (Agraph_t *) 0 ;
    Agnode_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agraph_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agraph_t, 1, 0);
    }
    gh_defer_ints();
    result = (Agnode_t *)firstnode(arg1);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agnode_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_nextnode__SWIG_0 (int argc, SCM *argv)
{
#define FUNC_NAME "nextnode"
    Agraph_t *arg1 = (Agraph_t *) 0 ;
    Agnode_t *arg2 = (Agnode_t *) 0 ;
    Agnode_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agraph_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agraph_t, 1, 0);
    }
    {
        arg2 = (Agnode_t *)SWIG_MustGetPtr(argv[1], SWIGTYPE_p_Agnode_t, 2, 0);
    }
    gh_defer_ints();
    result = (Agnode_t *)nextnode(arg1,arg2);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agnode_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_firstnode__SWIG_1 (int argc, SCM *argv)
{
#define FUNC_NAME "firstnode"
    Agedge_t *arg1 = (Agedge_t *) 0 ;
    Agnode_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agedge_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agedge_t, 1, 0);
    }
    gh_defer_ints();
    result = (Agnode_t *)firstnode(arg1);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agnode_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_firstnode(SCM rest)
{
    SCM argv[1];
    int argc = SWIG_Guile_GetArgs (argv, rest, 0, 1, "firstnode");
    if (argc == 1) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agraph_t, 0);
        }
        if (_v) {
            return _wrap_firstnode__SWIG_0(argc,argv);
        }
    }
    if (argc == 1) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agedge_t, 0);
        }
        if (_v) {
            return _wrap_firstnode__SWIG_1(argc,argv);
        }
    }
    
    scm_misc_error("firstnode", "No matching method for generic function `firstnode'", SCM_EOL);
}


static SCM
_wrap_nextnode__SWIG_1 (int argc, SCM *argv)
{
#define FUNC_NAME "nextnode"
    Agedge_t *arg1 = (Agedge_t *) 0 ;
    Agnode_t *arg2 = (Agnode_t *) 0 ;
    Agnode_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agedge_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agedge_t, 1, 0);
    }
    {
        arg2 = (Agnode_t *)SWIG_MustGetPtr(argv[1], SWIGTYPE_p_Agnode_t, 2, 0);
    }
    gh_defer_ints();
    result = (Agnode_t *)nextnode(arg1,arg2);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agnode_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_nextnode(SCM rest)
{
    SCM argv[2];
    int argc = SWIG_Guile_GetArgs (argv, rest, 0, 2, "nextnode");
    if (argc == 2) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agraph_t, 0);
        }
        if (_v) {
            {
                void *ptr;
                _v = !SWIG_ConvertPtr(argv[1], &ptr, SWIGTYPE_p_Agnode_t, 0);
            }
            if (_v) {
                return _wrap_nextnode__SWIG_0(argc,argv);
            }
        }
    }
    if (argc == 2) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agedge_t, 0);
        }
        if (_v) {
            {
                void *ptr;
                _v = !SWIG_ConvertPtr(argv[1], &ptr, SWIGTYPE_p_Agnode_t, 0);
            }
            if (_v) {
                return _wrap_nextnode__SWIG_1(argc,argv);
            }
        }
    }
    
    scm_misc_error("nextnode", "No matching method for generic function `nextnode'", SCM_EOL);
}


static SCM
_wrap_firstattr__SWIG_0 (int argc, SCM *argv)
{
#define FUNC_NAME "firstattr"
    Agraph_t *arg1 = (Agraph_t *) 0 ;
    Agsym_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agraph_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agraph_t, 1, 0);
    }
    gh_defer_ints();
    result = (Agsym_t *)firstattr(arg1);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agsym_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_nextattr__SWIG_0 (int argc, SCM *argv)
{
#define FUNC_NAME "nextattr"
    Agraph_t *arg1 = (Agraph_t *) 0 ;
    Agsym_t *arg2 = (Agsym_t *) 0 ;
    Agsym_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agraph_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agraph_t, 1, 0);
    }
    {
        arg2 = (Agsym_t *)SWIG_MustGetPtr(argv[1], SWIGTYPE_p_Agsym_t, 2, 0);
    }
    gh_defer_ints();
    result = (Agsym_t *)nextattr(arg1,arg2);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agsym_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_firstattr__SWIG_1 (int argc, SCM *argv)
{
#define FUNC_NAME "firstattr"
    Agedge_t *arg1 = (Agedge_t *) 0 ;
    Agsym_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agedge_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agedge_t, 1, 0);
    }
    gh_defer_ints();
    result = (Agsym_t *)firstattr(arg1);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agsym_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_nextattr__SWIG_1 (int argc, SCM *argv)
{
#define FUNC_NAME "nextattr"
    Agedge_t *arg1 = (Agedge_t *) 0 ;
    Agsym_t *arg2 = (Agsym_t *) 0 ;
    Agsym_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agedge_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agedge_t, 1, 0);
    }
    {
        arg2 = (Agsym_t *)SWIG_MustGetPtr(argv[1], SWIGTYPE_p_Agsym_t, 2, 0);
    }
    gh_defer_ints();
    result = (Agsym_t *)nextattr(arg1,arg2);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agsym_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_firstattr__SWIG_2 (int argc, SCM *argv)
{
#define FUNC_NAME "firstattr"
    Agnode_t *arg1 = (Agnode_t *) 0 ;
    Agsym_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agnode_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agnode_t, 1, 0);
    }
    gh_defer_ints();
    result = (Agsym_t *)firstattr(arg1);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agsym_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_firstattr(SCM rest)
{
    SCM argv[1];
    int argc = SWIG_Guile_GetArgs (argv, rest, 0, 1, "firstattr");
    if (argc == 1) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agraph_t, 0);
        }
        if (_v) {
            return _wrap_firstattr__SWIG_0(argc,argv);
        }
    }
    if (argc == 1) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agedge_t, 0);
        }
        if (_v) {
            return _wrap_firstattr__SWIG_1(argc,argv);
        }
    }
    if (argc == 1) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agnode_t, 0);
        }
        if (_v) {
            return _wrap_firstattr__SWIG_2(argc,argv);
        }
    }
    
    scm_misc_error("firstattr", "No matching method for generic function `firstattr'", SCM_EOL);
}


static SCM
_wrap_nextattr__SWIG_2 (int argc, SCM *argv)
{
#define FUNC_NAME "nextattr"
    Agnode_t *arg1 = (Agnode_t *) 0 ;
    Agsym_t *arg2 = (Agsym_t *) 0 ;
    Agsym_t *result;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agnode_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agnode_t, 1, 0);
    }
    {
        arg2 = (Agsym_t *)SWIG_MustGetPtr(argv[1], SWIGTYPE_p_Agsym_t, 2, 0);
    }
    gh_defer_ints();
    result = (Agsym_t *)nextattr(arg1,arg2);
    
    gh_allow_ints();
    {
        gswig_result = SWIG_NewPointerObj (result, SWIGTYPE_p_Agsym_t, 0);
    }
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_nextattr(SCM rest)
{
    SCM argv[2];
    int argc = SWIG_Guile_GetArgs (argv, rest, 0, 2, "nextattr");
    if (argc == 2) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agraph_t, 0);
        }
        if (_v) {
            {
                void *ptr;
                _v = !SWIG_ConvertPtr(argv[1], &ptr, SWIGTYPE_p_Agsym_t, 0);
            }
            if (_v) {
                return _wrap_nextattr__SWIG_0(argc,argv);
            }
        }
    }
    if (argc == 2) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agedge_t, 0);
        }
        if (_v) {
            {
                void *ptr;
                _v = !SWIG_ConvertPtr(argv[1], &ptr, SWIGTYPE_p_Agsym_t, 0);
            }
            if (_v) {
                return _wrap_nextattr__SWIG_1(argc,argv);
            }
        }
    }
    if (argc == 2) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agnode_t, 0);
        }
        if (_v) {
            {
                void *ptr;
                _v = !SWIG_ConvertPtr(argv[1], &ptr, SWIGTYPE_p_Agsym_t, 0);
            }
            if (_v) {
                return _wrap_nextattr__SWIG_2(argc,argv);
            }
        }
    }
    
    scm_misc_error("nextattr", "No matching method for generic function `nextattr'", SCM_EOL);
}


static SCM
_wrap_rm__SWIG_0 (int argc, SCM *argv)
{
#define FUNC_NAME "rm"
    Agraph_t *arg1 = (Agraph_t *) 0 ;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agraph_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agraph_t, 1, 0);
    }
    gh_defer_ints();
    rm(arg1);
    
    gh_allow_ints();
    gswig_result = SCM_UNSPECIFIED;
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_rm__SWIG_1 (int argc, SCM *argv)
{
#define FUNC_NAME "rm"
    Agnode_t *arg1 = (Agnode_t *) 0 ;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agnode_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agnode_t, 1, 0);
    }
    gh_defer_ints();
    rm(arg1);
    
    gh_allow_ints();
    gswig_result = SCM_UNSPECIFIED;
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_rm__SWIG_2 (int argc, SCM *argv)
{
#define FUNC_NAME "rm"
    Agedge_t *arg1 = (Agedge_t *) 0 ;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agedge_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agedge_t, 1, 0);
    }
    gh_defer_ints();
    rm(arg1);
    
    gh_allow_ints();
    gswig_result = SCM_UNSPECIFIED;
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_rm(SCM rest)
{
    SCM argv[1];
    int argc = SWIG_Guile_GetArgs (argv, rest, 0, 1, "rm");
    if (argc == 1) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agraph_t, 0);
        }
        if (_v) {
            return _wrap_rm__SWIG_0(argc,argv);
        }
    }
    if (argc == 1) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agnode_t, 0);
        }
        if (_v) {
            return _wrap_rm__SWIG_1(argc,argv);
        }
    }
    if (argc == 1) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agedge_t, 0);
        }
        if (_v) {
            return _wrap_rm__SWIG_2(argc,argv);
        }
    }
    
    scm_misc_error("rm", "No matching method for generic function `rm'", SCM_EOL);
}


static SCM
_wrap_layout (SCM s_0, SCM s_1)
{
#define FUNC_NAME "layout"
    Agraph_t *arg1 = (Agraph_t *) 0 ;
    char *arg2 ;
    int must_free2 = 0 ;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agraph_t *)SWIG_MustGetPtr(s_0, SWIGTYPE_p_Agraph_t, 1, 0);
    }
    {
        arg2 = SWIG_scm2str(s_1);
        must_free2 = 1;
    }
    gh_defer_ints();
    layout(arg1,arg2);
    
    gh_allow_ints();
    gswig_result = SCM_UNSPECIFIED;
    if (must_free2 && arg2) SWIG_free(arg2);
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_render__SWIG_0 (int argc, SCM *argv)
{
#define FUNC_NAME "render"
    Agraph_t *arg1 = (Agraph_t *) 0 ;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agraph_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agraph_t, 1, 0);
    }
    gh_defer_ints();
    render(arg1);
    
    gh_allow_ints();
    gswig_result = SCM_UNSPECIFIED;
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_render__SWIG_1 (int argc, SCM *argv)
{
#define FUNC_NAME "render"
    Agraph_t *arg1 = (Agraph_t *) 0 ;
    char *arg2 ;
    int must_free2 = 0 ;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agraph_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agraph_t, 1, 0);
    }
    {
        arg2 = SWIG_scm2str(argv[1]);
        must_free2 = 1;
    }
    gh_defer_ints();
    render(arg1,arg2);
    
    gh_allow_ints();
    gswig_result = SCM_UNSPECIFIED;
    if (must_free2 && arg2) SWIG_free(arg2);
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_render__SWIG_2 (int argc, SCM *argv)
{
#define FUNC_NAME "render"
    Agraph_t *arg1 = (Agraph_t *) 0 ;
    char *arg2 ;
    char *arg3 ;
    int must_free2 = 0 ;
    int must_free3 = 0 ;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agraph_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agraph_t, 1, 0);
    }
    {
        arg2 = SWIG_scm2str(argv[1]);
        must_free2 = 1;
    }
    {
        arg3 = SWIG_scm2str(argv[2]);
        must_free3 = 1;
    }
    gh_defer_ints();
    render(arg1,arg2,arg3);
    
    gh_allow_ints();
    gswig_result = SCM_UNSPECIFIED;
    if (must_free2 && arg2) SWIG_free(arg2);
    if (must_free3 && arg3) SWIG_free(arg3);
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_render__SWIG_3 (int argc, SCM *argv)
{
#define FUNC_NAME "render"
    Agraph_t *arg1 = (Agraph_t *) 0 ;
    char *arg2 ;
    FILE *arg3 = (FILE *) 0 ;
    int must_free2 = 0 ;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agraph_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agraph_t, 1, 0);
    }
    {
        arg2 = SWIG_scm2str(argv[1]);
        must_free2 = 1;
    }
    {
        arg3 = (FILE *)SWIG_MustGetPtr(argv[2], SWIGTYPE_p_FILE, 3, 0);
    }
    gh_defer_ints();
    render(arg1,arg2,arg3);
    
    gh_allow_ints();
    gswig_result = SCM_UNSPECIFIED;
    if (must_free2 && arg2) SWIG_free(arg2);
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_render__SWIG_4 (int argc, SCM *argv)
{
#define FUNC_NAME "render"
    Agraph_t *arg1 = (Agraph_t *) 0 ;
    char *arg2 ;
    void **arg3 = (void **) 0 ;
    int must_free2 = 0 ;
    SCM gswig_result;
    int gswig_list_p = 0;
    
    {
        arg1 = (Agraph_t *)SWIG_MustGetPtr(argv[0], SWIGTYPE_p_Agraph_t, 1, 0);
    }
    {
        arg2 = SWIG_scm2str(argv[1]);
        must_free2 = 1;
    }
    {
        arg3 = (void **)SWIG_MustGetPtr(argv[2], SWIGTYPE_p_p_void, 3, 0);
    }
    gh_defer_ints();
    render(arg1,arg2,arg3);
    
    gh_allow_ints();
    gswig_result = SCM_UNSPECIFIED;
    if (must_free2 && arg2) SWIG_free(arg2);
    
    return gswig_result;
#undef FUNC_NAME
}


static SCM
_wrap_render(SCM rest)
{
    SCM argv[3];
    int argc = SWIG_Guile_GetArgs (argv, rest, 0, 3, "render");
    if (argc == 1) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agraph_t, 0);
        }
        if (_v) {
            return _wrap_render__SWIG_0(argc,argv);
        }
    }
    if (argc == 2) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agraph_t, 0);
        }
        if (_v) {
            {
                _v = SCM_STRINGP(argv[1]) ? 1 : 0;
            }
            if (_v) {
                return _wrap_render__SWIG_1(argc,argv);
            }
        }
    }
    if (argc == 3) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agraph_t, 0);
        }
        if (_v) {
            {
                _v = SCM_STRINGP(argv[1]) ? 1 : 0;
            }
            if (_v) {
                {
                    void *ptr;
                    _v = !SWIG_ConvertPtr(argv[2], &ptr, SWIGTYPE_p_FILE, 0);
                }
                if (_v) {
                    return _wrap_render__SWIG_3(argc,argv);
                }
            }
        }
    }
    if (argc == 3) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agraph_t, 0);
        }
        if (_v) {
            {
                _v = SCM_STRINGP(argv[1]) ? 1 : 0;
            }
            if (_v) {
                {
                    void *ptr;
                    _v = !SWIG_ConvertPtr(argv[2], &ptr, SWIGTYPE_p_p_void, 0);
                }
                if (_v) {
                    return _wrap_render__SWIG_4(argc,argv);
                }
            }
        }
    }
    if (argc == 3) {
        int _v;
        {
            void *ptr;
            _v = !SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_Agraph_t, 0);
        }
        if (_v) {
            {
                _v = SCM_STRINGP(argv[1]) ? 1 : 0;
            }
            if (_v) {
                {
                    _v = SCM_STRINGP(argv[2]) ? 1 : 0;
                }
                if (_v) {
                    return _wrap_render__SWIG_2(argc,argv);
                }
            }
        }
    }
    
    scm_misc_error("render", "No matching method for generic function `render'", SCM_EOL);
}


#ifdef __cplusplus
extern "C" {
#endif

/* -------- TYPE CONVERSION AND EQUIVALENCE RULES (BEGIN) -------- */

static swig_type_info _swigt__p_FILE[] = {{"_p_FILE", 0, "FILE *", 0},{"_p_FILE"},{0}};
static swig_type_info _swigt__p_Agedge_t[] = {{"_p_Agedge_t", 0, "Agedge_t *", 0},{"_p_Agedge_t"},{0}};
static swig_type_info _swigt__p_Agsym_t[] = {{"_p_Agsym_t", 0, "Agsym_t *", 0},{"_p_Agsym_t"},{0}};
static swig_type_info _swigt__p_Agraph_t[] = {{"_p_Agraph_t", 0, "Agraph_t *", 0},{"_p_Agraph_t"},{0}};
static swig_type_info _swigt__p_Agnode_t[] = {{"_p_Agnode_t", 0, "Agnode_t *", 0},{"_p_Agnode_t"},{0}};
static swig_type_info _swigt__p_p_void[] = {{"_p_p_void", 0, "void **", 0},{"_p_p_void"},{0}};

static swig_type_info *swig_types_initial[] = {
_swigt__p_FILE, 
_swigt__p_Agedge_t, 
_swigt__p_Agsym_t, 
_swigt__p_Agraph_t, 
_swigt__p_Agnode_t, 
_swigt__p_p_void, 
0
};


/* -------- TYPE CONVERSION AND EQUIVALENCE RULES (END) -------- */

extern void
SWIG_init (void)
{
    static int _swig_init = 0;
    
    if (!_swig_init) {
        SWIG_Guile_RegisterTypes(swig_types, swig_types_initial);
        _swig_init = 1;
    }
    
    SWIG_Guile_Init();
    
    gh_new_procedure("digraph", (swig_guile_proc) _wrap_digraph, 1, 0, 0);
    gh_new_procedure("strictgraph", (swig_guile_proc) _wrap_strictgraph, 1, 0, 0);
    gh_new_procedure("strictdigraph", (swig_guile_proc) _wrap_strictdigraph, 1, 0, 0);
    gh_new_procedure("readstring", (swig_guile_proc) _wrap_readstring, 1, 0, 0);
    gh_new_procedure("read", (swig_guile_proc) _wrap_read, 0, 0, 1);
    gh_new_procedure("graph", (swig_guile_proc) _wrap_graph, 0, 0, 1);
    gh_new_procedure("node", (swig_guile_proc) _wrap_node, 2, 0, 0);
    gh_new_procedure("edge", (swig_guile_proc) _wrap_edge, 0, 0, 1);
    gh_new_procedure("setv", (swig_guile_proc) _wrap_setv, 0, 0, 1);
    gh_new_procedure("getv", (swig_guile_proc) _wrap_getv, 0, 0, 1);
    gh_new_procedure("nameof", (swig_guile_proc) _wrap_nameof, 0, 0, 1);
    gh_new_procedure("findsubg", (swig_guile_proc) _wrap_findsubg, 2, 0, 0);
    gh_new_procedure("findnode", (swig_guile_proc) _wrap_findnode, 2, 0, 0);
    gh_new_procedure("findedge", (swig_guile_proc) _wrap_findedge, 2, 0, 0);
    gh_new_procedure("findattr", (swig_guile_proc) _wrap_findattr, 0, 0, 1);
    gh_new_procedure("headof", (swig_guile_proc) _wrap_headof, 1, 0, 0);
    gh_new_procedure("tailof", (swig_guile_proc) _wrap_tailof, 1, 0, 0);
    gh_new_procedure("graphof", (swig_guile_proc) _wrap_graphof, 0, 0, 1);
    gh_new_procedure("rootof", (swig_guile_proc) _wrap_rootof, 1, 0, 0);
    gh_new_procedure("protonode", (swig_guile_proc) _wrap_protonode, 1, 0, 0);
    gh_new_procedure("protoedge", (swig_guile_proc) _wrap_protoedge, 1, 0, 0);
    gh_new_procedure("ok", (swig_guile_proc) _wrap_ok, 0, 0, 1);
    gh_new_procedure("firstsubg", (swig_guile_proc) _wrap_firstsubg, 1, 0, 0);
    gh_new_procedure("nextsubg", (swig_guile_proc) _wrap_nextsubg, 2, 0, 0);
    gh_new_procedure("firstsupg", (swig_guile_proc) _wrap_firstsupg, 1, 0, 0);
    gh_new_procedure("nextsupg", (swig_guile_proc) _wrap_nextsupg, 2, 0, 0);
    gh_new_procedure("firstedge", (swig_guile_proc) _wrap_firstedge, 0, 0, 1);
    gh_new_procedure("nextedge", (swig_guile_proc) _wrap_nextedge, 0, 0, 1);
    gh_new_procedure("firstout", (swig_guile_proc) _wrap_firstout, 0, 0, 1);
    gh_new_procedure("nextout", (swig_guile_proc) _wrap_nextout, 0, 0, 1);
    gh_new_procedure("firsthead", (swig_guile_proc) _wrap_firsthead, 1, 0, 0);
    gh_new_procedure("nexthead", (swig_guile_proc) _wrap_nexthead, 2, 0, 0);
    gh_new_procedure("firstin", (swig_guile_proc) _wrap_firstin, 0, 0, 1);
    gh_new_procedure("nextin", (swig_guile_proc) _wrap_nextin, 0, 0, 1);
    gh_new_procedure("firsttail", (swig_guile_proc) _wrap_firsttail, 1, 0, 0);
    gh_new_procedure("nexttail", (swig_guile_proc) _wrap_nexttail, 2, 0, 0);
    gh_new_procedure("firstnode", (swig_guile_proc) _wrap_firstnode, 0, 0, 1);
    gh_new_procedure("nextnode", (swig_guile_proc) _wrap_nextnode, 0, 0, 1);
    gh_new_procedure("firstattr", (swig_guile_proc) _wrap_firstattr, 0, 0, 1);
    gh_new_procedure("nextattr", (swig_guile_proc) _wrap_nextattr, 0, 0, 1);
    gh_new_procedure("rm", (swig_guile_proc) _wrap_rm, 0, 0, 1);
    gh_new_procedure("layout", (swig_guile_proc) _wrap_layout, 2, 0, 0);
    gh_new_procedure("render", (swig_guile_proc) _wrap_render, 0, 0, 1);
}

#ifdef __cplusplus
}
#endif
extern "C" {
/* Linkage: simple */

}

